# Copyright (C) 2013-2015 all contributors <yahns-public@yhbt.net>
# License: GPLv3 or later (https://www.gnu.org/licenses/gpl-3.0.txt)
module Yahns::ClientExpireGeneric # :nodoc:
  def __timestamp
    Yahns.now
  end

  def yahns_init
    super # Yahns::HttpClient#yahns_init
    @last_io_at = 0
  end

  def yahns_expire(timeout)
    return 0 if closed?
    if (__timestamp - @last_io_at) > timeout
      shutdown
      1
    else
      0
    end
  # shutdown may race with the shutdown in http_response_done
  rescue
    0
  end

  def kgio_trywrite(*args)
    @last_io_at = __timestamp
    super
  end

  def kgio_tryread(*args)
    @last_io_at = __timestamp
    super
  end

  def trysendfile(*args)
    @last_io_at = __timestamp
    super
  end
end
