# Copyright (C) 2014, all contributors <yahns-public@yhbt.net>
# License: GPLv3 or later (see COPYING for details)

require_relative 'acceptor'
require_relative 'openssl_client'

class Yahns::OpenSSLServer < Kgio::TCPServer # :nodoc:
  include Yahns::Acceptor

  def self.wrap(fd, ssl_ctx)
    srv = for_fd(fd)
    srv.instance_variable_set(:@ssl_ctx, ssl_ctx)
    srv
  end

  def kgio_accept(klass, flags)
    io = super
    io.yahns_init_ssl(@ssl_ctx)
    io
  end
end
